package jaredbgreat.dldungeons.pieces.chests;

import jaredbgreat.dldungeons.builder.Builder;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraft.world.World;
import net.minecraftforge.common.ChestGenHooks;

public class TreasureChest extends BasicChest {
	
	static ArrayList<Integer> slots = new ArrayList<Integer>();	
	int slot;
	
	public TreasureChest(int x, int y, int z, int level) {
		super(x, y, z, level);
	}
	
	@Override
	public void place(World world, int x, int y, int z, Random random) {
		Collections.shuffle(slots, random);
		slot = 0;
		level += random.nextInt(2);
		ItemStack treasure;
		Builder.placeBlock(world, x, y, z, chest, 0, 2);
		TileEntityChest contents = (TileEntityChest)world.getTileEntity(x, y, z);
		vanillaChest(contents, random);
		int num = random.nextInt(2 + (level / 3)) + 2;
		for(int i = 0; i < num; i++) {
			treasure = LootCategory.heal.levels[level].getLoot(random).getStack(random);
			if(contents.getStackInSlot(slot) != null) slot++;
			contents.setInventorySlotContents(slots.get(slot++).intValue(), treasure);
		}
		num = random.nextInt(2 + (level / 3)) + 2;
		for(int i = 0; i < num; i++) {
			treasure = LootCategory.gear.levels[level].getLoot(random).getStack(random);
			if(contents.getStackInSlot(slot) != null) slot++;
			contents.setInventorySlotContents(slots.get(slot++).intValue(), treasure);
			if(slot > 26) return;  // This should not happen, but better safe than sorry
		}
		num = random.nextInt(3 + (level / 2)) + 3;
		for(int i = 0; i < num; i++) {
			treasure = LootCategory.loot.levels[level].getLoot(random).getStack(random);
			if(contents.getStackInSlot(slot) != null) slot++;
			contents.setInventorySlotContents(slots.get(slot++).intValue(), treasure);
			if(slot > 26) return;  // This should not happen, but better safe than sorry
		}
		if(random.nextInt(9) < level) {
			if(level >= 7) treasure = LootList.special.getLoot(random).getStack(random);
			else treasure = LootList.discs.getLoot(random).getStack(random);
			if(contents.getStackInSlot(slot) != null) slot++;
			contents.setInventorySlotContents(slots.get(slot++).intValue(), treasure);
			if(slot > 26) return;  // This should not happen, but better safe than sorry
		}
	}
	
	
	private void vanillaChest(TileEntityChest chest, Random random) {
		int which = random.nextInt(4);
		ChestGenHooks chinf;
		switch (which) {
		case 0:
			chinf = ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_DESERT_CHEST);
			break;
		case 1:
			chinf = ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_CHEST);
			break;
		default:
			chinf = ChestGenHooks.getInfo(ChestGenHooks.DUNGEON_CHEST);
			break;
		}		
        WeightedRandomChestContent.generateChestContents(random, 
        		chinf.getItems(random), chest, chinf.getCount(random));
	}
	
	
	public static void initSlots() {
		for(int i = 0; i < 27; i++) slots.add(new Integer(i));
	}
}
